;==========================================================
;Header
;==========================================================
        .nolist
#ifdef  VTI
    #define TI83P
#endif
    #include    "keyval.inc"
        #include        "ion.inc"
        .list

#ifdef  TI83P
        .org    progstart-2
        .db     $BB,$6D
#else
        .org    progstart
#endif
        ret
        jr      nc,start_of_program
        .db     "Langtons Ant",0

start_of_program:

;==========================================================
; start of program
;==========================================================
    call gsClearbuffer
    call gsEnable
    call gsSetFreq
    call gsClearbuffer

; Yet another Langton's ant program :p
; Langton's Snake
; What you see is simply the trail of the ant's
; last 20 steps. Requisted by a friend of mine 
; who thought it would look cool. I think it does :)
; 2nd quits
; Mode changes between "trail" and "normal" mode

;============================================================ 
; Initiate Program
;============================================================ 
Begin:
 LD A,6
 LD (X),A
 LD A,31
 LD (Y),A
 LD A,%10000000
 LD (Xbyte),A
 LD HL,X
 LD DE,X+3
 LD BC,30
 LDIR

 LD A,$FF
 OUT (1),A
 LD A,%10111111
 OUT (1),A
 
;============================================================ 
; Check for keypresses
; If 2nd is pressed, quit
; If Mode is pressed, switch screen
;============================================================ 

Loop: 
 IN A,(1)
 SUB %11011111      
 JR NZ,MainLoop
 CPL
 OUT (1),A
 JP gsDisable
;============================================================ 
; Locate the byte in antbuf where the ant currently is,
; and the associated byte in gbuf
; OUT:  HL = byte in antbuf
;   DE = byte in gbuf
;============================================================ 
MainLoop:
 LD H,0
 LD L,H
 LD B,H
 LD A,(X)
 LD C,A
 ADD HL,BC
 LD A,(Y)
 ADD A,A
 ADD A,A
 LD C,A
 ADD HL,BC
 ADD HL,BC
 ADD HL,BC
 LD B,H
 LD C,L
 LD HL,gbuf
 ADD HL,BC
 EX DE,HL
 LD HL,antbuf
 ADD HL,BC

;============================================================ 
; Check the tile the ant stands on in antbuf, rotate it
; according to the rules, and "move" the trail of the ant one pixel
;============================================================ 
 LD A,(Xbyte)
 XOR (HL)
 CP (HL)

 LD (HL),A      ; Remember, this doesn't affect
 LD A,(Orientation) ; the flags

 JR C,blacktile
whitetile
 RRCA
 RRCA
blacktile 
 RLCA
 LD (Orientation),A

 LD A,(Xbyte)
 EX DE,HL
 OR (HL)
 LD (HL),A

 LD HL,gbuf
 LD B,0
 LD A,(XLast)
 LD C,A
 ADD HL,BC
 LD A,(YLast)
 ADD A,A
 ADD A,A
 LD C,A
 ADD HL,BC
 ADD HL,BC
 ADD HL,BC
 LD A,(XbyteLast)
 CPL
 AND (HL)
 LD (HL),A

 LD HL,Loop
 PUSH HL 

;============================================================ 
; Move the trail
;============================================================ 

 LD DE,XbyteLast
 LD HL,XbyteLast-3
 LD BC,180
 LDDR

;============================================================ 
; Move the Ant
;============================================================

 LD A,(Orientation)
 LD C,A
 LD A,%10001000
 CP C
 JR Z,Left
 RLCA
 CP C
 JR Z,Up
 RLCA
 CP C
 JR Z,Right

Down:
 LD A,(Y)
 INC A
 LD (Y),A
 sub 64
 ret NZ
 LD (Y),A
 ret

Left:
 LD A,(Xbyte)
 RLCA
 LD (Xbyte),A
 RET NC
 LD A,(X)
 OR A
 JR NZ,Left2
 LD A,12
Left2
 DEC A
 LD (X),A
 ret

Up: 
 LD A,(Y)
 OR A
 JR NZ,Up2
 LD A,64
Up2
 DEC A
 LD (Y),A
 RET

Right:
 LD A,(Xbyte)
 RRCA
 LD (Xbyte),A
 RET NC
 LD A,(X)
 INC A
 LD (X),A
 SUB 12
 RET NZ
 LD (X),A
 RET

;============================================================ 
; Miscelanious data
;============================================================
gbufoffset  .db $00
        .dw gbuf-12-(-(12*64)+1)
Orientation .db %00010001
X:      = saferam2
Y:      = saferam2+1
Xbyte:      = saferam2+2
XLast:      = saferam2+180
YLast:      = saferam2+181
XbyteLast:  = saferam2+182

;==========================================================
; grayscale include file
;==========================================================
; comment these defines in or out to activate/deactivate them

#DEFINE NODOUBLEBUFFER ;when on,routines write directly to screen (faster and smaller)
;#DEFINE 3LEVELGRAY ;makes it 3-level grayscale (a bit faster)
;#DEFINE XORSPRITE  ;includes gsPutSprite
;#DEFINE LARGESPRITE    ;includes gsLargeSprite
;#DEFINE ALIGNEDSPRITE  ;includes gsAlignedsprite
;#DEFINE ALIGNEDMASKEDSPRITE

#include graylib.inc
antbuf = gbuf2
.end
END
