.nolist
    #include    "ti83plus.inc"
.list
.org    $9D93
.db t2ByteTok, tAsmCmp
gbuf = plotSScreen
antbuf = appBackUpScreen

; Yet another Langton's ant program :p
; Langton's Snake
; What you see is simply the trail of the ant's
; last 20 steps. Requisted by a friend of mine 
; who thought it would look cool. I think it does :)
; 2nd quits
; Mode changes between "trail" and "normal" mode

;============================================================ 
; Initiate Program
;============================================================ 
Begin:
 b_call(_ClrLCDFull)
 b_call(_ForceFullScreen
 b_call(_GrBufClr)
 LD HL,antbuf
 b_call(_BufClr)
 DI

 LD A,6
 LD (X),A
 LD A,31
 LD (Y),A
 LD A,%10000000
 LD (Xbyte),A
 LD HL,X
 LD DE,X+3
 LD BC,30
 LDIR

 LD A,$FF
 OUT (1),A
 LD A,%10111111
 OUT (1),A
 
;============================================================ 
; Check for keypresses
; If 2nd is pressed, quit
; If Mode is pressed, switch screen
;============================================================ 

Loop: 
 IN A,(1)
 SUB %11011111		
 JR NZ,TestMode
 CPL
 OUT (1),A
 EI
 RET
TestMode:
 IN A,(1)
 SUB %10111111
 JR NZ,MainLoop
 LD A,(gbufoffset)
 OR A
 JR Z,gbuf_to_antbuf
 LD HL,gbuf-12-(-(12*64)+1)
 LD (gbufoffset+1),HL
 JR switch
gbuf_to_antbuf
 LD HL,antbuf-12-(-(12*64)+1)
 LD (gbufoffset+1),HL
switch:
 CPL
 LD (gbufoffset),A
;============================================================ 
; Locate the byte in antbuf where the ant currently is,
; and the associated byte in gbuf
; OUT: 	HL = byte in antbuf
;	DE = byte in gbuf
;============================================================ 
MainLoop:
 LD H,0
 LD L,H
 LD B,H
 LD A,(X)
 LD C,A
 ADD HL,BC
 LD A,(Y)
 ADD A,A
 ADD A,A
 LD C,A
 ADD HL,BC
 ADD HL,BC
 ADD HL,BC
 LD B,H
 LD C,L
 LD HL,gbuf
 ADD HL,BC
 EX DE,HL
 LD HL,antbuf
 ADD HL,BC

;============================================================ 
; Check the tile the ant stands on in antbuf, rotate it
; according to the rules, and "move" the trail of the ant one pixel
;============================================================ 
 LD A,(Xbyte)
 XOR (HL)
 CP (HL)

 LD (HL),A		; Remember, this doesn't affect
 LD A,(Orientation)	; the flags

 JR C,blacktile
whitetile
 RRCA
 RRCA
blacktile 
 RLCA
 LD (Orientation),A

 LD A,(Xbyte)
 EX DE,HL
 OR (HL)
 LD (HL),A

 LD HL,gbuf
 LD B,0
 LD A,(XLast)
 LD C,A
 ADD HL,BC
 LD A,(YLast)
 ADD A,A
 ADD A,A
 LD C,A
 ADD HL,BC
 ADD HL,BC
 ADD HL,BC
 LD A,(XbyteLast)
 CPL
 AND (HL)
 LD (HL),A

 LD HL,fcopy
 PUSH HL 

;============================================================ 
; Move the trail
;============================================================ 

 LD DE,XbyteLast
 LD HL,XbyteLast-3
 LD BC,180
 LDDR

;============================================================ 
; Move the Ant
;============================================================

 LD A,(Orientation)
 LD C,A
 LD A,%10001000
 CP C
 JR Z,Left
 RLCA
 CP C
 JR Z,Up
 RLCA
 CP C
 JR Z,Right

Down:
 LD A,(Y)
 INC A
 LD (Y),A
 sub 64
 ret NZ
 LD (Y),A
 ret

Left:
 LD A,(Xbyte)
 RLCA
 LD (Xbyte),A
 RET NC
 LD A,(X)
 OR A
 JR NZ,Left2
 LD A,12
Left2
 DEC A
 LD (X),A
 ret

Up: 
 LD A,(Y)
 OR A
 JR NZ,Up2
 LD A,64
Up2
 DEC A
 LD (Y),A
 RET

Right:
 LD A,(Xbyte)
 RRCA
 LD (Xbyte),A
 RET NC
 LD A,(X)
 INC A
 LD (X),A
 SUB 12
 RET NZ
 LD (X),A
 POP HL
;============================================================ 
; Copy the currently selected buffer to the screen
;============================================================ 
fcopy:
	ld	a,$80				; 7
	out	($10),a				; 11
	ld	hl,(gbufoffset+1)		; 10
	ld	a,$20				; 7
	ld	c,a				; 4
	inc	hl				; 6 waste
	dec	hl				; 6 waste
fastCopyAgain:
	ld	b,64				; 7
	inc	c				; 4
	ld	de,-(12*64)+1			; 10
	out	($10),a				; 11
	add	hl,de				; 11
	ld	de,10				; 10
fastCopyLoop:
	add	hl,de				; 11
	inc	hl				; 6 waste
	inc	hl				; 6 waste
	inc	de				; 6
	ld	a,(hl)				; 7
	out	($11),a				; 11
	dec	de				; 6
	djnz	fastCopyLoop			; 13/8
	ld	a,c				; 4
	cp	$2B+1				; 7
	jr	nz,fastCopyAgain		; 10/1
	jp Loop

;============================================================ 
; Miscelanious data
;============================================================
gbufoffset	.db $00
		.dw gbuf-12-(-(12*64)+1)
Orientation	.db %00010001
X:		= saveSScreen
Y:		= saveSScreen+1
Xbyte:		= saveSScreen+2
XLast:		= saveSScreen+180
YLast:		= saveSScreen+181
XbyteLast:	= saveSScreen+182
.end
.end